/* default bindings to load into the Tcl hash-tables */

/*************************************************************************/
/*  it's a waste of time to edit this file now -- you can do a binding   */
/*  to get the same effect:                                              */
/*    bind dcc o status *status     <- makes '.status' only require 'o'  */
/*  that's easier to do and doesn't require a recompile.                 */
/*************************************************************************/


/* access required */
#define NEED_PARTY  1
#define NEED_XFER   2
#define NEED_OP     4
#define NEED_MASTER 8
#define NEED_OWNER  16

#define END_FIELD   { NULL, NULL, -1 }

/* stupid function prototypes */
int msg_die(), msg_hello(), msg_help(), msg_ident(), msg_info(), msg_invite(),
  msg_jump(), msg_memory(), msg_op(), msg_pass(), msg_rehash(), msg_reset(),
  msg_status(), msg_who(), msg_whois(), msg_email(), msg_notes(), msg_go();

/* MSG COMMANDS */
/* function call should be:
   int msg_cmd("handle","nick","user@host","params");
   function is responsible for any logging
   (return 1 if successful, 0 if not) */
cmd_t C_msg[]={
  { "die", msg_die, NEED_OWNER },
  { "email", msg_email, 0 },
  { "go", msg_go, NEED_OP },
  { "hello", msg_hello, 0 },
  { "help", msg_help, 0 },
  { "ident", msg_ident, 0 },
  { "info", msg_info, 0 },
  { "invite", msg_invite, NEED_OP },
  { "jump", msg_jump, NEED_MASTER },
  { "memory", msg_memory, NEED_MASTER },
  { "notes", msg_notes, 0 },
  { "op", msg_op, NEED_OP },
  { "pass", msg_pass, 0 },
  { "rehash", msg_rehash, NEED_MASTER },
  { "reset", msg_reset, NEED_MASTER },
  { "status", msg_status, NEED_MASTER },
  { "who", msg_who, 0 },
  { "whois", msg_whois, 0 },
  END_FIELD
};


/* function prototypes, take two */
void cmd_pls_ban(), cmd_pls_bot(), cmd_chat(), cmd_pls_host(), cmd_pls_ignore(),
  cmd_pls_user(), cmd_mns_ban(), cmd_mns_host(), cmd_botinfo(), cmd_chinfo(),
  cmd_mns_ignore(), cmd_mns_user(), cmd_act(), cmd_addlog(),
  cmd_away(), cmd_bans(), cmd_boot(), cmd_bots(), cmd_chaddr(), cmd_channel(),
  cmd_chpass(), cmd_comment(), cmd_console(), cmd_dccstat(), cmd_debug(),
  cmd_define(), cmd_die(), cmd_deop(), cmd_dump(), cmd_email(), cmd_reload(),
  cmd_files(), cmd_handle(), cmd_help(), cmd_ignores(), cmd_info(),
  cmd_invite(), cmd_jump(), cmd_kick(), cmd_kickban(), cmd_link(), cmd_match(),
  cmd_me(), cmd_msg(), cmd_motd(), cmd_newpass(), cmd_note(), cmd_op(),
  cmd_rehash(), cmd_relay(), cmd_reset(), cmd_resetbans(), cmd_save(),
  cmd_say(), cmd_servers(), cmd_set(), cmd_simul(), cmd_status(), cmd_trace(),
  cmd_unlink(), cmd_who(), cmd_whois(), cmd_whom(), cmd_chemail(), cmd_echo(),
  cmd_pls_kick(), cmd_mns_kick(), cmd_bottree(), cmd_pls_reject(), cmd_notes(),
  cmd_mns_reject(), cmd_mns_common(), cmd_topic(), cmd_banner(), cmd_nick(),
  cmd_chattr(), cmd_adduser(), cmd_assoc(), cmd_tcl(), cmd_binds();

/* DCC CHAT COMMANDS */
/* function call should be:
   int cmd_whatever(idx,z,"parameters");
   as with msg commands, function is responsible for any logging
*/
cmd_t C_dcc[]={
  { "+ban", (Function)cmd_pls_ban, NEED_OP },
  { "+bot", (Function)cmd_pls_bot, NEED_MASTER },
  { "+host", (Function)cmd_pls_host, NEED_MASTER },
  { "+ignore", (Function)cmd_pls_ignore, NEED_MASTER },
  { "+user", (Function)cmd_pls_user, NEED_MASTER },
  { "-ban", (Function)cmd_mns_ban, NEED_OP },
  { "-bot", (Function)cmd_mns_user, NEED_MASTER },
  { "-host", (Function)cmd_mns_host, NEED_MASTER },
  { "-ignore", (Function)cmd_mns_ignore, NEED_MASTER },
  { "-user", (Function)cmd_mns_user, NEED_MASTER },
  { "act", (Function)cmd_act, NEED_OP },
  { "addlog", (Function)cmd_addlog, NEED_OP },
  { "adduser", (Function)cmd_adduser, NEED_MASTER },
  { "assoc", (Function)cmd_assoc, NEED_MASTER },
  { "away", (Function)cmd_away, 0 },
  { "banner", (Function)cmd_banner, NEED_MASTER },
  { "bans", (Function)cmd_bans, NEED_OP },
  { "binds", (Function)cmd_binds, NEED_MASTER },
  { "boot", (Function)cmd_boot, NEED_MASTER },
  { "botinfo", (Function)cmd_botinfo, 0 },
  { "bots", (Function)cmd_bots, 0 },
  { "bottree", (Function)cmd_bottree, 0 },
  { "chaddr", (Function)cmd_chaddr, NEED_MASTER },
  { "channel", (Function)cmd_channel, NEED_OP },
  { "chat", (Function)cmd_chat, 0 },
  { "chattr", (Function)cmd_chattr, NEED_MASTER },
  { "chemail", (Function)cmd_chemail, NEED_MASTER },
  { "chinfo", (Function)cmd_chinfo, NEED_MASTER },
  { "chpass", (Function)cmd_chpass, NEED_MASTER },
  { "comment", (Function)cmd_comment, NEED_MASTER },
  { "console", (Function)cmd_console, NEED_OP },
  { "dccstat", (Function)cmd_dccstat, NEED_MASTER },
  { "debug", (Function)cmd_debug, NEED_MASTER },
  { "deop", (Function)cmd_deop, NEED_OP },
  { "die", (Function)cmd_die, NEED_OWNER },
  { "dump", (Function)cmd_dump, NEED_MASTER },
  { "echo", (Function)cmd_echo, 0 },
  { "email", (Function)cmd_email, 0 },
  { "files", (Function)cmd_files, 0 },
  { "handle", (Function)cmd_handle, NEED_MASTER },
  { "help", (Function)cmd_help, 0 },
  { "ignores", (Function)cmd_ignores, NEED_MASTER },
  { "info", (Function)cmd_info, 0 },
  { "invite", (Function)cmd_invite, NEED_OP },
  { "jump", (Function)cmd_jump, NEED_MASTER },
  { "kick", (Function)cmd_kick, NEED_OP },
  { "kickban", (Function)cmd_kickban, NEED_OP },
  { "link", (Function)cmd_link, NEED_MASTER },
  { "match", (Function)cmd_match, NEED_OP },
  { "me", (Function)cmd_me, 0 },
  { "motd", (Function)cmd_motd, 0 },
  { "msg", (Function)cmd_msg, NEED_OP },
  { "newpass", (Function)cmd_newpass, 0 },
  { "nick", (Function)cmd_nick, NEED_OP },
  { "note", (Function)cmd_note, 0 },
  { "notes", (Function)cmd_notes, 0 },
  { "op", (Function)cmd_op, NEED_OP },
  { "quit", CMD_LEAVE, 0 },
  { "rehash", (Function)cmd_rehash, NEED_MASTER },
  { "relay", (Function)cmd_relay, NEED_MASTER },
  { "reload", (Function)cmd_reload, NEED_MASTER },
  { "reset", (Function)cmd_reset, NEED_MASTER },
  { "resetbans", (Function)cmd_resetbans, NEED_OP },
  { "save", (Function)cmd_save, NEED_MASTER },
  { "say", (Function)cmd_say, NEED_OP },
  { "servers", (Function)cmd_servers, NEED_OP },
  { "set", (Function)cmd_set, NEED_OWNER },
#ifdef ENABLE_SIMUL
  { "simul", (Function)cmd_simul, NEED_OWNER },
#endif
  { "status", (Function)cmd_status, NEED_MASTER },
#ifdef ENABLE_TCL
  { "tcl", (Function)cmd_tcl, NEED_OWNER },
#endif
  { "topic", (Function)cmd_topic, NEED_OP },
  { "trace", (Function)cmd_trace, NEED_MASTER },
  { "unlink", (Function)cmd_unlink, NEED_MASTER },
  { "who", (Function)cmd_who, 0 },
  { "whois", (Function)cmd_whois, NEED_OP },
  { "whom", (Function)cmd_whom, 0 },
  END_FIELD
};


/* bleh. */
int cmd_chdir(), cmd_desc(), cmd_get(), cmd_file_help(), cmd_hide(),
  cmd_unhide(), cmd_ls(), cmd_mv(), cmd_pwd(), cmd_rm(), cmd_cp(),
  cmd_mkdir(), cmd_rmdir(), cmd_pending(), cmd_cancel(), cmd_ln(),
  cmd_share(), cmd_unshare(), cmd_lsa();

/* FILE AREA COMMANDS */
/* function call should be:
   int cmd_whatever(idx,z,"parameters");
   as with msg commands, function is responsible for any logging
*/
cmd_t C_file[]={
  { "cancel", cmd_cancel, 0 },
  { "cd", cmd_chdir, 0 },
  { "chdir", cmd_chdir, 0 },
  { "cp", cmd_cp, NEED_MASTER },
  { "desc", cmd_desc, 0 },
  { "get", cmd_get, 0 },
  { "help", cmd_file_help, 0 },
  { "hide", cmd_hide, NEED_MASTER },
  { "ln", cmd_ln, 0 },
  { "ls", cmd_ls, 0 },
  { "lsa", cmd_lsa, 0 },
  { "mkdir", cmd_mkdir, NEED_MASTER },
  { "mv", cmd_mv, NEED_MASTER },
  { "note", (Function)cmd_note, 0 },        /* ditto */
  { "pending", cmd_pending, 0 },
  { "pwd", cmd_pwd, 0 },
  { "quit", CMD_LEAVE, 0 },
  { "rm", cmd_rm, NEED_MASTER },
  { "rmdir", cmd_rmdir, NEED_MASTER },
  { "share", cmd_share, NEED_MASTER },
  { "unhide", cmd_unhide, NEED_MASTER },
  { "unshare", cmd_unshare, NEED_MASTER },
  END_FIELD
};


/* this sucks!! */
int tand_pls_attr(), tand_pls_ban(), tand_killuser(), tand_link_cmd(),
  tand_pls_host(), tand_pls_ignore(), tand_mns_attr(), tand_mns_ban(),
  tand_mns_ignore(), tand_senduf(), tand_handshake(), tand_linked(),
  tand_bye(), tand_chat(), tand_chcomment(), tand_chemail(), tand_zapfbroad(),
  tand_chdccdir(), tand_chinfo(), tand_chhand(), tand_chpass(), tand_trying(),
  tand_newuser(), tand_ping(), tand_pong(), tand_end_trying(), tand_zapf(),
  tand_priv(), tand_reject(), tand_resync(), tand_resync_no(), tand_resyncq(),
  tand_trace(), tand_traced(), tand_ufno(), tand_ufyes(), tand_unlink_cmd(),
  tand_unlinked(), tand_userfileq(), tand_version(), tand_whoq(),
  tand_whom(), tand_who(), tand_nlinked(), tand_thisbot(), tand_infoq(),
  tand_motd(), tand_chan(), tand_actchan(), tand_chattr(), tand_pls_banchan(),
  tand_clrxtra(), tand_addxtra(), tand_assoc(), tand_mns_banchan(),
  tand_filereq(), tand_filereject(), tand_filesend(), tand_mns_host(),
  tand_ufsend(), tand_error();

/* TANDEM BOT COMMANDS */
/* function call should be:
   int tand_whatever(idx,z,"parameters");
*/
cmd_t C_tand[]={
  { "*trying", tand_end_trying, 0 },
  { "+ban", tand_pls_ban, 0 },
  { "+banchan", tand_pls_banchan, 0 },
  { "+host", tand_pls_host, 0 },
  { "+ignore", tand_pls_ignore, 0 },
  { "-ban", tand_mns_ban, 0 },
  { "-banchan", tand_mns_banchan, 0 },
  { "-host", tand_mns_host, 0 },
  { "-ignore", tand_mns_ignore, 0 },
  { "actchan", tand_actchan, 0 },
  { "addxtra", tand_addxtra, 0 },
  { "assoc", tand_assoc, 0 },
  { "bye", tand_bye, 0 },
  { "chan", tand_chan, 0 },
  { "chat", tand_chat, 0 },
  { "chcomment", tand_chcomment, 0 },
  { "chdccdir", tand_chdccdir, 0 },
  { "chemail", tand_chemail, 0 },
  { "chattr", tand_chattr, 0 },
  { "chhand", tand_chhand, 0 },
  { "chinfo", tand_chinfo, 0 },
  { "chpass", tand_chpass, 0 },
  { "clrxtra", tand_clrxtra, 0 },
  { "error", tand_error, 0 },
  { "filereject", tand_filereject, 0 },
  { "filereq", tand_filereq, 0 },
  { "filesend", tand_filesend, 0 },
  { "handshake", tand_handshake, 0 },
  { "info?", tand_infoq, 0 },
  { "killuser", tand_killuser, 0 },
  { "link", tand_link_cmd, 0 },
  { "linked", tand_linked, 0 },
  { "motd", tand_motd, 0 },
  { "newuser", tand_newuser, 0 },
  { "nlinked", tand_nlinked, 0 },
  { "ping", tand_ping, 0 },
  { "pong", tand_pong, 0 },
  { "priv", tand_priv, 0 },
  { "reject", tand_reject, 0 },
  { "resync!", tand_resync, 0 },
  { "resync-no", tand_resync_no, 0 },
  { "resync?", tand_resyncq, 0 },
  { "thisbot", tand_thisbot, 0 },
  { "trace", tand_trace, 0 },
  { "traced", tand_traced, 0 },
  { "trying", tand_trying, 0 },
  { "uf-no", tand_ufno, 0 },
  { "uf-yes", tand_ufyes, 0 },
  { "ufsend", tand_ufsend, 0 },
  { "unlink", tand_unlink_cmd, 0 },
  { "unlinked", tand_unlinked, 0 },
  { "userfile?", tand_userfileq, 0 },
  { "version", tand_version, 0 },
  { "who", tand_who, 0 },
  { "who?", tand_whoq, 0 },
  { "whom", tand_whom, 0 },
  { "zapf", tand_zapf, 0 },
  { "zapf-broad", tand_zapfbroad, 0 },
  END_FIELD
};
